
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.testmod.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;

import net.minecraft.world.level.levelgen.placement.PlacedFeature;
import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.Holder;

import net.mcreator.testmod.world.features.ores.RubyOreFeature;
import net.mcreator.testmod.world.features.ores.LuminiteOreFeature;
import net.mcreator.testmod.world.features.ores.DeathOreFeature;
import net.mcreator.testmod.world.features.ores.DarkMatterFeature;
import net.mcreator.testmod.world.features.ores.AquadiniumOreFeature;
import net.mcreator.testmod.world.features.UpgradedDungeonFeature;
import net.mcreator.testmod.world.features.DarkTreeXLFeature;
import net.mcreator.testmod.world.features.DarkDungeonFeature;
import net.mcreator.testmod.TestmodMod;

import java.util.function.Supplier;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;

@Mod.EventBusSubscriber
public class TestmodModFeatures {
	public static final DeferredRegister<Feature<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.FEATURES, TestmodMod.MODID);
	private static final List<FeatureRegistration> FEATURE_REGISTRATIONS = new ArrayList<>();
	public static final RegistryObject<Feature<?>> DARK_MATTER = register("dark_matter", DarkMatterFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, DarkMatterFeature.GENERATE_BIOMES, DarkMatterFeature::placedFeature));
	public static final RegistryObject<Feature<?>> DEATH_ORE = register("death_ore", DeathOreFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, DeathOreFeature.GENERATE_BIOMES, DeathOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> LUMINITE_ORE = register("luminite_ore", LuminiteOreFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, LuminiteOreFeature.GENERATE_BIOMES, LuminiteOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> DARK_DUNGEON = register("dark_dungeon", DarkDungeonFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.SURFACE_STRUCTURES, DarkDungeonFeature.GENERATE_BIOMES, DarkDungeonFeature::placedFeature));
	public static final RegistryObject<Feature<?>> AQUADINIUM_ORE = register("aquadinium_ore", AquadiniumOreFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, AquadiniumOreFeature.GENERATE_BIOMES, AquadiniumOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> RUBY_ORE = register("ruby_ore", RubyOreFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, RubyOreFeature.GENERATE_BIOMES, RubyOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> DARK_TREE_XL = register("dark_tree_xl", DarkTreeXLFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.SURFACE_STRUCTURES, DarkTreeXLFeature.GENERATE_BIOMES, DarkTreeXLFeature::placedFeature));
	public static final RegistryObject<Feature<?>> UPGRADED_DUNGEON = register("upgraded_dungeon", UpgradedDungeonFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.SURFACE_STRUCTURES, UpgradedDungeonFeature.GENERATE_BIOMES,
					UpgradedDungeonFeature::placedFeature));

	private static RegistryObject<Feature<?>> register(String registryname, Supplier<Feature<?>> feature, FeatureRegistration featureRegistration) {
		FEATURE_REGISTRATIONS.add(featureRegistration);
		return REGISTRY.register(registryname, feature);
	}

	@SubscribeEvent
	public static void addFeaturesToBiomes(BiomeLoadingEvent event) {
		for (FeatureRegistration registration : FEATURE_REGISTRATIONS) {
			if (registration.biomes() == null || registration.biomes().contains(event.getName()))
				event.getGeneration().getFeatures(registration.stage()).add(registration.placedFeature().get());
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			Supplier<Holder<PlacedFeature>> placedFeature) {
	}
}
